package jp.co.nextdesign.view;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;
import java.util.List;

import org.apache.wicket.extensions.markup.html.repeater.data.sort.SortOrder;
import org.apache.wicket.extensions.markup.html.repeater.util.SortableDataProvider;
import org.apache.wicket.model.AbstractReadOnlyModel;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.PropertyModel;

public class UserProvider extends SortableDataProvider<Contact,String> {
	private static final long serialVersionUID = 1L;
	
    class SortableDataProviderComparator implements Comparator<Contact>, Serializable {
    	private static final long serialVersionUID = 1L;
        public int compare(final Contact o1, final Contact o2) {
            PropertyModel<Comparable<String>> model1 = new PropertyModel<Comparable<String>>(o1, getSort().getProperty());
            PropertyModel<Comparable<String>> model2 = new PropertyModel<Comparable<String>>(o2, getSort().getProperty());
            int result = model1.getObject().compareTo((String)model2.getObject());
            if (!getSort().isAscending()) {
                result = -result;
            }
            return result;
        }
    }

    private List<Contact> list = new ArrayList<Contact>();
    private SortableDataProviderComparator comparator = new SortableDataProviderComparator();

    public UserProvider() {
        // The default sorting
        setSort("name.first", SortOrder.ASCENDING);
        list.add(new Contact(new Name("Abby", "Zerind", "111-222-3333")));
        list.add(new Contact(new Name("Bernard", "Youst", "111-222-4444")));
        list.add(new Contact(new Name("Charlie", "Xerg", "111-222-5555")));
        list.add(new Contact(new Name("Deitri", "West", "111-222-6666")));
        list.add(new Contact(new Name("Ernie", "Vuntang", "111-222-7777")));
        list.add(new Contact(new Name("Frank", "Unter", "111-222-8888")));
    }

    @Override
    public Iterator<Contact> iterator(final long first, final long count) {
        // In this example the whole list gets copied, sorted and sliced; in real applications typically your database would deliver a sorted and limited list 
        // Get the data
        List<Contact> newList = new ArrayList<Contact>(list);
        // Sort the data
        Collections.sort(newList, comparator);
        // Return the data for the current page - this can be determined only after sorting
        return newList.subList((int)first, (int)(first + count)).iterator();
    }

    @Override
    public IModel<Contact> model(final Contact object) {
        return new AbstractReadOnlyModel<Contact>() {
        private static final long serialVersionUID = 1L;
           @Override
            public Contact getObject() {
                return object;
            }
        };
    }

    @Override
    public long size() {
        return list.size();
    }
}

class Contact implements Serializable {
	private static final long serialVersionUID = 1L;
    private final Name name;
    public Contact(final Name name) {
        this.name = name;
    }

    public Name getName() {
        return name;
    }
}

class Name implements Serializable {
	private static final long serialVersionUID = 1L;
    private String firstName;
    private String lastName;
    private String homePhone;
    public Name(final String fName, final String lName, String homePhone) {
        firstName = fName;
        lastName = lName;
        this.homePhone = homePhone;
    }

    public String getFirst() {
        return firstName;
    }

    public String getLast() {
        return lastName;
    }

    public void setFirst(final String firstName) {
        this.firstName = firstName;
    }

    public void setLast(final String lastName) {
        this.lastName = lastName;
    }

	public String getHomePhone() {
		return homePhone;
	}

	public void setHomePhone(String homePhone) {
		this.homePhone = homePhone;
	}
}